org.apache.felix.bundlerepository

## Interface Resource

All Known Subinterfaces:
  LocalResource

All Known Implementing Classes:
  ConvertedResource, LazyLocalResourceImpl, LocalResourceImpl, ResourceImpl

    public interface Resource

A resource is an abstraction of a downloadable thing, like a bundle. Resources have capabilities and requirements. All a resource's requirements must be satisfied before it can be installed.

### Field Summary

Fields
`static java.lang.String` `CATEGORY`
`static java.lang.String` `COPYRIGHT`
`static java.lang.String` `DESCRIPTION`
`static java.lang.String` `DOCUMENTATION_URI`
`static java.lang.String` `ID`
`static java.lang.String` `JAVADOC_URI`
`static java.lang.String` `LICENSE_URI`
`static java.lang.String` `MANIFEST_VERSION`
`static java.lang.String` `PRESENTATION_NAME`
`static java.lang.String` `SIZE`
`static java.lang.String` `SOURCE_URI`
`static java.lang.String` `SYMBOLIC_NAME`
`static java.lang.String` `URI`
`static java.lang.String` `VERSION`

### Method Summary

Methods
`Capability[]` `getCapabilities()` Retrieve the capabilities
`java.lang.String[]` `getCategories()` Retrieve this resource categories
`java.lang.String` `getId()` Shortcut for {{getProperties().get(ID)}}
`java.lang.String` `getPresentationName()` Shortcut for {{getProperties().get(PRESENTATION_NAME)}}
`java.util.Map` `getProperties()` Get all resource properties
`Requirement[]` `getRequirements()` Retrieve the requirements
`java.lang.Long` `getSize()` Shortcut for {{getProperties().get(SIZE)}}
`java.lang.String` `getSymbolicName()` Shortcut for {{getProperties().get(SYMBOLIC_NAME)}}
`java.lang.String` `getURI()` Shortcut for {{getProperties().get(URI)}}
`org.osgi.framework.Version` `getVersion()` Shortcut for {{getProperties().get(VERSION)}}
`boolean` `isLocal()` Returns whether this resource is a local one or not.

### Field Detail

#### LICENSE_URI

    static final java.lang.String LICENSE_URI

See Also:
  Constant Field Values

#### DESCRIPTION

    static final java.lang.String DESCRIPTION

See Also:
  Constant Field Values

#### DOCUMENTATION_URI

    static final java.lang.String DOCUMENTATION_URI

See Also:
  Constant Field Values

#### COPYRIGHT

    static final java.lang.String COPYRIGHT

See Also:
  Constant Field Values

#### SOURCE_URI

    static final java.lang.String SOURCE_URI

See Also:
  Constant Field Values

#### JAVADOC_URI

    static final java.lang.String JAVADOC_URI

See Also:
  Constant Field Values

#### SYMBOLIC_NAME

    static final java.lang.String SYMBOLIC_NAME

See Also:
  Constant Field Values

#### PRESENTATION_NAME

    static final java.lang.String PRESENTATION_NAME

See Also:
  Constant Field Values

#### ID

    static final java.lang.String ID

See Also:
  Constant Field Values

#### VERSION

    static final java.lang.String VERSION

See Also:
  Constant Field Values

#### URI

    static final java.lang.String URI

See Also:
  Constant Field Values

#### SIZE

    static final java.lang.String SIZE

See Also:
  Constant Field Values

#### CATEGORY

    static final java.lang.String CATEGORY

See Also:
  Constant Field Values

#### MANIFEST_VERSION

    static final java.lang.String MANIFEST_VERSION

See Also:
  Constant Field Values

### Method Detail

#### getProperties

    java.util.Map getProperties()

Get all resource properties

Returns:

#### getId

    java.lang.String getId()

Shortcut for {{getProperties().get(ID)}}

Returns:

#### getSymbolicName

    java.lang.String getSymbolicName()

Shortcut for {{getProperties().get(SYMBOLIC_NAME)}}

Returns:

#### getVersion

    org.osgi.framework.Version getVersion()

Shortcut for {{getProperties().get(VERSION)}}

Returns:

#### getPresentationName

    java.lang.String getPresentationName()

Shortcut for {{getProperties().get(PRESENTATION_NAME)}}

Returns:

#### getURI

    java.lang.String getURI()

Shortcut for {{getProperties().get(URI)}}

Returns:

#### getSize

    java.lang.Long getSize()

Shortcut for {{getProperties().get(SIZE)}}

Returns:

#### getCategories

    java.lang.String[] getCategories()

Retrieve this resource categories

Returns:

#### getCapabilities

    Capability[] getCapabilities()

Retrieve the capabilities

Returns:

#### getRequirements

    Requirement[] getRequirements()

Retrieve the requirements

Returns:

#### isLocal

    boolean isLocal()

Returns whether this resource is a local one or not. Local resources are already available in the OSGi framework and thus will be preferred over other resources.